#include "polybius.h"


void cryptPolybius(const char *filename, const char *key){
    char polybius[POLYBIUS_SIZE][POLYBIUS_SIZE];

    generateSquarePolybius(polybius, key);

    for (int i = 0; i < POLYBIUS_SIZE; i++){
        for (int j = 0; j < POLYBIUS_SIZE; j++)
            printf("%c ", polybius[i][j]);
        printf("\n");
    }
}
/*
 This function fill the polybius square
 */
static void fillSquare(char c, int pos, char polybius[POLYBIUS_SIZE][POLYBIUS_SIZE]){
    for (int i = 0; i < POLYBIUS_SIZE; i++)
        polybius[pos][i] = c + i;
}
static int findKeyInSquare(const char *polybius, char c){
    for (int i = 0; i < 26; i++)
        if (c == polybius[i])
            return 1;

    return 0;
}
/*
 This function generate the polybius square
 */
void generateSquarePolybius(char polybius[POLYBIUS_SIZE][POLYBIUS_SIZE], const char *key){
    char a[26] = {0};
    fillSquare('A', 0, polybius);
    polybius[1][0] = 'F';
    polybius[1][1] = 'G';
    polybius[1][2] = 'H';
    polybius[1][3] = 'I';
    polybius[1][4] = 'K';
    fillSquare('L', 2, polybius);
    fillSquare('Q', 3, polybius);
    fillSquare('V', 4, polybius);

    /*
        char a[26];
        a[0] = 'A'; a[1] = 'B'; .... a[25] = 'Z';
        // We add the key into the a array and with a function
        // and with the function, we check if the character already exist in the array
        // If yes, we do not add it

        // After that, we convert to the polybius[5][5]
    */
    int pos = 0;
    for (int i = 0; i < strlen(key); i++){
        char k;
        if (key[i] >= 'a' && key[i] <= 'z')
            k = key[i] - 32; // 32 = 26 + some characters
        else k = key[i];
        int res = findKeyInSquare(a, k);
        if (res == 0)
            a[pos++] = k;
    }
    int n = 0;
    int t = pos;
    for (int i = pos; i < 26 - pos; i++){
        char c = 'A' + n;
        int res = findKeyInSquare(a, c);

        if (res == 0){
            a[t++] = c;
            n++;
        }
        else printf("Find key: %c\n", c);
        //printf("%d\n", n);
    }
    for (int i = 0; i < 26; i++)
        printf("%c\n", a[i]);
}
